Type Octree
	Field child:Octree[8]
	
	Method Write(x:Int, y:Int, z:Int, size:Int)
		Local half:Int = size/2
		If z < half Then
			If y < half Then
				If x < half Then
					If Not child[0] Then 
						child[0] = New octree
					End If
					If half > 1 Then 
						child[0].Write(x, y, z, half)
					End If
				Else
					If Not child[1] Then 
						child[1] = New octree
					End If
					If half > 1 Then 
						child[1].Write(x-half, y, z, half)
					End If
				End If
			Else
				If x < half Then
					If Not child[2] Then 
						child[2] = New octree
					End If
					If half > 1 Then 
						child[2].Write(x, y-half, z, half)
					End If
				Else
					If Not child[3] Then 
						child[3] = New octree
					End If
					If half > 1 Then 
						child[3].Write(x-half, y-half, z, half)
					End If
				End If
			End If
		Else
			If y < half Then
				If x < half Then
					If Not child[4] Then 
						child[4] = New octree
					End If
					If half > 1 Then 
						child[4].Write(x, y, z-half, half)
					End If
				Else
					If Not child[5] Then 
						child[5] = New octree
					End If
					If half > 1 Then 
						child[5].Write(x-half, y, z-half, half)
					End If
				End If
			Else
				If x < half Then
					If Not child[6] Then 
						child[6] = New octree
					End If
					If half > 1 Then 
						child[6].Write(x, y-half, z-half, half)
					End If
				Else
					If Not child[7] Then 
						child[7] = New octree
					End If
					If half > 1 Then 
						child[7].Write(x-half, y-half, z-half, half)
					End If
				End If
			End If
		End If
	End Method
	
	
	Method Remove:Byte(x:Int, y:Int, z:Int, size:Int, lvl:Int)
		Local half:Int = size/2
		If z < half Then
			If y < half Then
				If x < half Then
					If Not child[0] Then
						Return 0
					Else
						If lvl > 1 Then
							Return child[0].Remove(x, y, z, half, lvl-1)
						Else
							child[0] = Null
							Return 1
						EndIf
					EndIf
				Else
					If Not child[1] Then
						Return 0
					Else
						If lvl > 1 Then
							Return child[1].Remove(x-half, y, z, half, lvl-1)
						Else
							child[1] = Null
							Return 1
						EndIf
					EndIf
				EndIf
			Else
				If x < half Then
					If Not child[2] Then 
						Return 0
					Else
						If lvl > 1 Then
							Return child[2].Remove(x, y-half, z, half, lvl-1)
						Else
							child[2] = Null
							Return 1
						End If
					End If
				Else
					If Not child[3] Then 
						Return 0
					Else
						If lvl > 1 Then
							Return child[3].Remove(x-half, y-half, z, half, lvl-1)
						Else
							child[3] = Null
							Return 1
						End If
					End If
				End If
			End If
		Else
			If y < half Then
				If x < half Then
					If Not child[4] Then 
						Return 0
					Else
						If lvl > 1 Then 
							Return child[4].Remove(x, y, z-half, half, lvl-1)
						Else
							child[4] = Null
							Return 1
						End If
					End If
				Else
					If Not child[5] Then 
						Return 0
					Else
						If lvl > 1 Then
							Return child[5].Remove(x-half, y, z-half, half, lvl-1)
						Else
							child[5] = Null
							Return 1
						End If
					End If
				End If
			Else
				If x < half Then
					If Not child[6] Then 
						Return 0
					Else
						If lvl > 1 Then
							Return child[6].Remove(x, y-half, z-half, half, lvl-1)
						Else
							child[6] = Null
							Return 1
						End If
					End If
				Else
					If Not child[7] Then 
						Return 0
					Else
						If lvl > 1 Then 
							Return child[7].Remove(x-half, y-half, z-half, half, lvl-1)
						Else
							child[7] = Null
							Return 1
						End If
					End If
				End If
			End If
		End If
	EndMethod
	
	
	Method TidyUp:Byte(x:Int, y:Int, z:Int, size:Int)
		Local half:Int = size/2
		If z < half Then
			If y < half Then
				If x < half Then
					If Not child[0] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[0].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[0] = Null
							Return 1
						Else
							Return child[0].TidyUp(x, y, z, half)
						EndIf
					EndIf
				Else
					If Not child[1] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[1].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[1] = Null
							Return 1
						Else
							Return child[1].TidyUp(x-half, y, z, half)
						EndIf
					EndIf
				EndIf
			Else
				If x < half Then
					If Not child[2] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[2].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[2] = Null
							Return 1
						Else
							Return child[2].TidyUp(x, y-half, z, half)
						EndIf
					EndIf
				Else
					If Not child[3] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[3].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[3] = Null
							Return 1
						Else
							Return child[3].TidyUp(x-half, y-half, z, half)
						EndIf
					EndIf
				EndIf
			EndIf
		Else
			If y < half Then
				If x < half Then
					If Not child[4] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[4].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[4] = Null
							Return 1
						Else
							Return child[4].TidyUp(x, y, z-half, half)
						EndIf
					EndIf
				Else
					If Not child[5] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[5].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[5] = Null
							Return 1
						Else
							Return child[5].TidyUp(x-half, y, z-half, half)
						EndIf
					EndIf
				EndIf
			Else
				If x < half Then
					If Not child[6] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[6].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[6] = Null
							Return 1
						Else
							Return child[6].TidyUp(x, y-half, z-half, half)
						EndIf
					EndIf
				Else
					If Not child[7] Then
						Return 0 
					Else
						Local useless:Byte = True
						For Local i:Int = 0 Until 8
							If child[7].child[i] <> Null Then useless = False
						Next
						If useless = True Then
							child[7] = Null
							Return 1
						Else
							Return child[7].TidyUp(x-half, y-half, z-half, half)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndMethod
	
	
	Method GetState:Byte(x:Int, y:Int, z:Int, size:Int, lvl:Int, bd:Int[])
		Local half:Int = size/2
		If z < half Then
			If y < half Then
				If x < half Then
					If Not child[0] Then 
						bd[0] :+ half
						bd[1] :+ half
						bd[2] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							Return child[0].GetState(x, y, z, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				Else
					If Not child[1] Then 
						bd[0] :+ size
						bd[1] :+ half
						bd[2] :+ half
						bd[3] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[0] :+ half
							bd[3] :+ half
							Return child[1].GetState(x-half, y, z, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				End If
			Else
				If x < half Then
					If Not child[2] Then 
						bd[0] :+ half
						bd[1] :+ size
						bd[2] :+ half
						bd[4] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[1] :+ half
							bd[4] :+ half
							Return child[2].GetState(x, y-half, z, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				Else
					If Not child[3] Then 
						bd[0] :+ size
						bd[1] :+ size
						bd[2] :+ half
						bd[3] :+ half
						bd[4] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[0] :+ half
							bd[1] :+ half
							bd[3] :+ half
							bd[4] :+ half
							Return child[3].GetState(x-half, y-half, z, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				End If
			End If
		Else
			If y < half Then
				If x < half Then
					If Not child[4] Then 
						bd[0] :+ half
						bd[1] :+ half 
						bd[2] :+ size
						bd[5] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[2] :+ half
							bd[5] :+ half
							Return child[4].GetState(x, y, z-half, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				Else
					If Not child[5] Then 
						bd[0] :+ size
						bd[1] :+ half
						bd[2] :+ size
						bd[3] :+ half
						bd[5] :+ half
						Return 0
					Else
						If lvl > 1 Then
							bd[0] :+ half
							bd[2] :+ half
							bd[3] :+ half
							bd[5] :+ half 
							Return child[5].GetState(x-half, y, z-half, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				End If
			Else
				If x < half Then
					If Not child[6] Then 
						bd[0] :+ half
						bd[1] :+ size
						bd[2] :+ size
						bd[4] :+ half
						bd[5] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[1] :+ half
							bd[2] :+ half
							bd[4] :+ half
							bd[5] :+ half
							Return child[6].GetState(x, y-half, z-half, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				Else
					If Not child[7] Then 
						bd[0] :+ size
						bd[1] :+ size
						bd[2] :+ size
						bd[3] :+ half
						bd[4] :+ half
						bd[5] :+ half
						Return 0
					Else
						If lvl > 1 Then 
							bd[0] :+ half
							bd[1] :+ half
							bd[2] :+ half
							bd[3] :+ half
							bd[4] :+ half
							bd[5] :+ half
							Return child[7].GetState(x-half, y-half, z-half, half, lvl-1, bd)
						Else
							Return 1
						End If
					End If
				End If
			End If
		End If
	End Method
End Type